.586p
.model flat,c
assume cs: flat, ds: flat, es: flat, fs: flat, gs: flat, ss: flat

include vesa.inc

.data
ib infoblok {}
mb modeblok {}
srp simrealpass {}
deflowered byte 0
lowbuffer_seg dw 0
lowbuffer_sel dw 0
lowbuffer dd 0
modes dw 256 dup (0)
bytes_per_page dd 0
llama_linear dd 0
lin1 dd 0
lin2 dd 0
yoko db 0
pm_stuff dd 0
fn_7 dd 0
vesaerror dd 0
err_pmode db "Can't get protected mode interface$"
err_lowmem db "Can't allocate low memory for buffer, and I only wanted 512 bytes$" 
err_initcard db "Can't initialize VBE2 card- maybe you don't have one?$"
err_getmode db "Can't get mode info$"
err_hardnotsup db "Your hardware is too crap to support the mode you want$"
err_nolfb db "Ok, who hid the Linear Frame Buffer?$"
err_modeset db "Your stupid gfx card won't let me set the mode$"
err_fizmap db "Physical address mapping has failed. Is life worth living?$"
savebx dw 0
savecx dw 0
mem64 dw 0
cx_scr2 dw 0
dx_scr2 dw 0
extern req_xres:word
extern req_yres:word
extern req_bpp:byte
extern have_a_mode:word
extern num_pages:byte
public vesaerror
public modes
public llama_linear
public bytes_per_page
public mem64
.code



llama_okseebye proc public
    cld

    cmp lowbuffer,0
    je noneed_low       ; no low mem allocated

    mov ax,101h
    mov dx,lowbuffer_sel
    int 31h             ;free low memory

    noneed_low:

    cmp llama_linear,0
    je noneed_lfb       ;no phs addr mapping

    mov ax,801h
    mov bx,savebx
    mov cx,savecx
    int 31h             ;free phys. addr. mapping

    noneed_lfb:

    mov ah,0
    mov al,3
    int 10h             ;back to text mode

    ret
llama_okseebye endp


llama_flip proc public
    mov ebx,0 ; req for both= tell fn 7 to set, not get
    mov eax,4f07h ; req for both- [not on my card though...]

    cmp yoko,1
    je devil_hunter

    ;yoko=0 screen 1 is showing. ll=lin2. -yoko=1 ll=lin1 displayline req_yres
    mov ecx,lin1
    mov llama_linear,ecx
    mov yoko,1
    mov cx,cx_scr2
    mov dx,dx_scr2
    call [fn_7]
    ret

    devil_hunter:
    ;yoko=1 screen 2 showing. ll=lin1. -yoko=0 ll=lin2. displine 0
    mov ecx,lin2
    mov llama_linear,ecx
    mov yoko,0
    mov ecx,0
    mov edx,0
    call [fn_7]
    ret

llama_flip endp

llama_flip_wait proc public
    mov ebx,0 ; req for both= tell fn 7 to set, not get
    mov eax,4f07h ; req for both- [not on my card though...]
    mov bl,80h ; wait for vbi
    cmp yoko,1
    je devil_hunter2

    ;yoko=0 screen 1 is showing. ll=lin2. -yoko=1 ll=lin1 displayline req_yres
    mov ecx,lin1
    mov llama_linear,ecx
    mov yoko,1
    mov cx,cx_scr2
    mov dx,dx_scr2
    call [fn_7]
    ret

    devil_hunter2:
    ;yoko=1 screen 2 showing. ll=lin1. -yoko=0 ll=lin2. displine 0
    mov ecx,lin2
    mov llama_linear,ecx
    mov yoko,0
    mov ecx,0
    mov edx,0
    call [fn_7]
    ret

llama_flip_wait endp

vesainit proc public
    cld

    mov vesaerror,0
    cmp deflowered,0
    je setitupthen
    ret

    setitupthen:
    mov deflowered,1

    mov ax,100h
    mov bx,32
    int 31h                 ;allocate 512 low bytes
    jnc lowmemok
    mov vesaerror,offset err_lowmem
    jmp end_init

    lowmemok:
    mov lowbuffer_sel,dx
    mov ecx,0
    mov cx,ax
    mov lowbuffer_seg,cx    ;save addr of lowbuffer
    shl ecx,4
    mov lowbuffer,ecx


    mov dword ptr [ecx],"2EBV"

    mov ax,lowbuffer_seg
    mov srp.ses,ax
    mov srp.seax,4f00h          ;setup regs to pass to simreal
    mov srp.sedi,0
    mov ax,300h
    mov bl,10h
    mov bh,0
    mov cx,0


    mov dx,seg srp
    mov es,dx
    mov edi,offset srp
    int 31h                 ;simulate realmode interrupt for getvesainfo
    cmp dword ptr [edi+1ch],4fh
    je initok
    mov vesaerror,offset err_initcard
    jmp end_init

    initok:

    mov ecx,128
    mov esi,lowbuffer       ; from lowbuffer
    mov edi,offset ib            ;to struct
    rep movsd               ;go go memory transfer!


    mov ax,ib.totmem
    mov mem64,ax ; so c knows how much mem is there
    ;read the mode list
    mov eax,0
    mov ebx,0
    mov ax,word ptr [ib.vidmodes+2]
    mov bx,word ptr [ib.vidmodes]
    shl eax,4
    add eax,ebx

    mov esi,eax
    mov edi,offset modes
    moderead:
    mov ax,[esi]
    cmp ax,0ffffh
    je jumpgate
    movsw
    jmp moderead
    jumpgate:
    movsw               ;ensures that our own modelist ends with 0ffffh


    mov srp.seax,4f0Ah          ;setup regs to pass to simreal
    mov srp.sebx,0
    mov ax,300h
    mov bl,10h
    mov bh,0
    mov cx,0
    mov dx,seg srp
    mov es,dx
    mov edi,offset srp
    int 31h                 ;simulate realmode interrupt for getvesainfo
    cmp dword ptr [edi+1ch],4fh
    je pm_ok
    mov vesaerror,offset err_pmode
    jmp end_init
    pm_ok:
    mov eax,0
    mov ebx,0
    mov ax,word ptr [edi+34] ; the returned es
    shl eax,4
    mov bx,word ptr [edi+0] ; the returned di
    add eax,ebx
    mov pm_stuff,eax ; linear addr of pm interface
    mov fn_7,eax
    mov ebx,eax 
    add ebx,2   ;linear addr of word offset in table
    mov ecx,0
    mov cx,word ptr [ebx] ; word offset in table of code
    add fn_7,ecx ; linear addr of pm_set_start



    end_init:
    cmp vesaerror,0
    je everythingok
    mov ah,09h
    mov edx,vesaerror
    int 21h

    everythingok:
    ret

vesainit endp

retmodeinfo proc public
    cld

    mov eax,0
    mov ax,have_a_mode
    and ax,01ffh ;from qlib
    mov srp.secx,eax
    mov ax,lowbuffer_seg
    mov srp.ses,ax
    mov srp.seax,4f01h          ;setup regs to pass to simreal
    mov srp.sedi,0
    mov ax,300h
    mov bl,10h
    mov bh,0
    mov cx,0

    mov dx,seg srp
    mov es,dx
    mov edi,offset srp
    int 31h                 ;simulate realmode interrupt for getmodeinfo

    cmp dword ptr [edi+1ch],4fh
    je modeok
    mov vesaerror,offset err_getmode
    jmp end_mode

    modeok:

    mov ecx,64
    mov esi,lowbuffer       ; 256 bytes from lowbuffer
    mov edi,offset mb       ; to modeinfo struct

    rep movsd               ; go go memory transfer!

    mov ax,mb.xres
    mov req_xres,ax
    mov ax,mb.yres
    mov req_yres,ax


    mov al,mb.bpp
    mov req_bpp,al
    mov al,mb.numpages
    mov num_pages,al



    end_mode:
    cmp vesaerror,0
    je everythingok2
    mov ah,09h
    mov edx,vesaerror
    int 21h
    everythingok2:
    ret
retmodeinfo endp

setmode proc public
    cld

    test mb.modeattr,1
    jnz hmm
    mov vesaerror,offset err_hardnotsup
    jmp set_mode
    hmm:
    test mb.modeattr,128
    jnz hmm2
    mov vesaerror,offset err_nolfb
    hmm2:
    ;yay the mode is supported by hardware and lfb is available
	;code to check size and set bytes_per_page was here
    ;ready to set mode
    mov ax,4f02h
    mov bx,have_a_mode
    add bx,4000h ; add on the fact we want lfb
    int 10h ;set the fucking mode, (we got there in the end- but we ain't done yet!)
    cmp ax,4fh
    je thank_god
    mov vesaerror,offset err_modeset
    jmp set_mode
    thank_god:
    ;wow- we actually have the mode set- gimme a handle on the LFB NOW!
    mov    ebx,mb.fiz_base_point
    mov    cx,bx
    shr    ebx,16
    mov    si,ib.totmem
    xor    edi,edi
    mov    ax,0800h                ; map physical memory
    int    31h
    jnc    notbad
    mov vesaerror,offset err_fizmap
    jmp set_mode
    notbad:
    mov savebx,bx
    mov savecx,cx
    shl    ebx,16
    mov    bx,cx
    mov    lin1,ebx ; save linear address

    add ebx,bytes_per_page
    mov lin2,ebx  ; save linear address for page 2
    mov llama_linear,ebx ; llama_linear points to 2nd screen [1st is showing]

    mov yoko,0
    ;set up cx and dx for scr2 select
    mov edx,bytes_per_page
    shr edx,2
    mov cx,dx
    shr edx,16
    mov cx_scr2,cx
    mov dx_scr2,dx
    set_mode:
    cmp vesaerror,0
    je everythingok3
    mov ah,09h
    mov edx,vesaerror
    int 21h
    everythingok3:

    ret
setmode endp


.stack

end

